/* Ich bin eine Kante.
   Kanten haben zwei Endknoten, ein Gewicht, eine Farbe, eine besucht-Markierung und ein tag,
   wo man alles ablegen kann, was man moechte.
   Alle Laufzeiten sind O(1).
 */
public class Edge {
    public Vertice fromVertice = null;      //erster Endknoten
    public Vertice toVertice   = null;     //zweiter Endknoten
    public int     weight      = 0;       //Gewicht
    public boolean visited     = false;  //Wurde die Kante besucht?
    public int     color       = 0;     //Farbe (0 fuer ungefaerbt)
    public Object  tag         = null; //alles, was man sonst noch haben moechte


    /* erzeugt eine neue Kante zwischen den Knoten from und to mit dem Gewicht 0.
       Laufzeit: O(1)
     */
    public Edge(Vertice from, Vertice to) {
        this(from, to, 0);
    }


    /* erzeugt eine neue Kante zwischen den Knoten from und to mit dem Gewicht weight.
       Laufzeit: O(1)
     */
    public Edge(Vertice from, Vertice to, int w) {
        fromVertice = from;
        toVertice   = to;
        weight      = w;
    }



    /* gibt das andere Ende der Kante zurueck.
       Laufzeit: O(1)
     */
    public Vertice otherEnd(Vertice firstEnd) {
        return (firstEnd.id == fromVertice.id? toVertice : fromVertice);
    }
}